#ifndef REMOTECONTROL_H
#define REMOTECONTROL_H

#include "InterfaceDefine.hpp"
#include <wx/grid.h>

class LogControl;
class ClientCore;
class RemoteControl : public wxPanel
{
public:
    RemoteControl(wxWindow* parent, std::shared_ptr<ClientCore>& clientCore);
    ~RemoteControl() override;

public:
    void setRemoteID(const wxString& id);

public:
    void SetLogControl(LogControl* logControl);

private:
    void Init();
    void SetGrid();
    void BindEvent();

private:
    void AskHome(wxCommandEvent& event);
    void GetDirContent(wxCommandEvent& event);

public:
    wxGrid* grid_;
    wxTextCtrl* textCtrl_;
    wxTextCtrl* edRemoteId_;
    wxButton* btnHome_;
    wxButton* btnGet_;
    wxButton* btnUpLevel_;
    wxButton* btnRefresh_;

private:
    LogControl* logControl_;
    std::shared_ptr<ClientCore> clientCore_;
};

#endif   // REMOTECONTROL_H